diff --git a/game/client/src/main/java/net/minecraft/client/gui/ItemElement.java b/game/client/src/main/java/net/minecraft/client/gui/ItemElement.java
index 219689e0c..5123037c4 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ItemElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ItemElement.java
@@ -2,19 +2,19 @@ package net.minecraft.client.gui;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.Lighting;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.item.model.ItemModel;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.WeightedRandomBag;
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.client.gui.guidebook.SlotGuidebook;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.opengl.GL12;
 
 public class ItemElement extends Gui {
     Minecraft mc;
@@ -29,8 +29,8 @@ public class ItemElement extends Gui {
 
         // Do setup
         Lighting.enableInventoryLight();
-        GL11.glColor4f(1, 1, 1, 1);
-        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+        GLRenderer.setColor4f(1f, 1f, 1f, 1f);
+//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
 
         // Draw slot background
         if (slot != null) {
@@ -38,34 +38,34 @@ public class ItemElement extends Gui {
             if (slot.getItemIcon() != null) {
                 final IconCoordinate iconIndex = TextureRegistry.getTexture(slot.getItemIcon());
                 if (itemStack == null) {
-                    GL11.glDisable(GL11.GL_LIGHTING);
+                    GLRenderer.globalSetLightEnabled(false);
                     this.drawTexturedIcon(x, y, 16, 16, iconIndex);
-                    GL11.glEnable(GL11.GL_LIGHTING);
+                    GLRenderer.globalSetLightEnabled(true);
                     hasDrawnSlotBackground = true;
                 }
             }
 
             if (slot.isLocked()) {
-                GL11.glColor4f(1, 1, 1, 1);
-                GL11.glDisable(GL11.GL_LIGHTING);
+                GLRenderer.setColor4f(1f, 1f, 1f, 1f);
+                GLRenderer.globalSetLightEnabled(false);
                 final IconCoordinate iconCoordinate = TextureRegistry.getTexture("minecraft:gui/slot_locked");
                 this.drawGuiIcon(x - 1, y - 1, 18, 18, iconCoordinate);
-                GL11.glEnable(GL11.GL_LIGHTING);
+                GLRenderer.globalSetLightEnabled(true);
             }
         }
 
         // Draw item
         if (!hasDrawnSlotBackground) {
-            GL11.glEnable(GL11.GL_DEPTH_TEST);
+            GLRenderer.enableState(State.DEPTH_TEST);
             if (itemStack != null) {
                 final ItemModel itemModel = ItemModelDispatcher.getInstance().getDispatch(itemStack.getItem());
-                itemModel.renderGui(Tessellator.instance, null, itemStack, x, y, discovered ? 1.0f : 0.0f, 1.0f, 1f);
-                if (slot instanceof SlotGuidebook) {
-                    if (((SlotGuidebook) slot).recipe instanceof RecipeEntryTrommel && ((SlotGuidebook) slot).item != null && ((SlotGuidebook) slot).isOutput) {
-                        final WeightedRandomBag<WeightedRandomLootObject> loot = ((RecipeEntryTrommel) ((SlotGuidebook) slot).recipe).getOutput();
+                itemModel.renderGui(GLRenderer.getTessellator(), null, itemStack, x, y, discovered ? LightmapHelper.getLightmapCoord(15, 15) : LightmapHelper.getLightmapCoord(0, 0), 1f);
+                if (slot instanceof SlotGuidebook slotGuidebook) {
+                    if (slotGuidebook.recipe instanceof RecipeEntryTrommel recipeEntryTrommel && slotGuidebook.item != null && slotGuidebook.isOutput) {
+                        final WeightedRandomBag<WeightedRandomLootObject> loot = recipeEntryTrommel.getOutput();
                         int index = slot.index;
-                        if (((SlotGuidebook) slot).recipeAmount > 8) {
-                            index = slot.index + (9 * ((SlotGuidebook) slot).recipeIndex);
+                        if (slotGuidebook.recipeAmount > 8) {
+                            index = slot.index + (9 * slotGuidebook.recipeIndex);
                         }
                         final WeightedRandomLootObject lootObject = loot.getEntries().get(index);
                         final String s;
@@ -74,31 +74,30 @@ public class ItemElement extends Gui {
                         } else {
                             s = String.valueOf(lootObject.getFixedYield());
                         }
-                        itemModel.renderItemOverlayIntoGUI(Tessellator.instance, this.mc.font, this.mc.textureManager, itemStack, x, y, discovered ? s : "?", 1.0f);
+                        itemModel.renderItemOverlayIntoGUI(GLRenderer.getTessellator(), this.mc.font, this.mc.textureManager, itemStack, x, y, discovered ? s : "?", 1.0f);
                     } else {
-                        itemModel.renderItemOverlayIntoGUI(Tessellator.instance, this.mc.font, this.mc.textureManager, itemStack, x, y, discovered ? null : "?", 1.0f);
+                        itemModel.renderItemOverlayIntoGUI(GLRenderer.getTessellator(), this.mc.font, this.mc.textureManager, itemStack, x, y, discovered ? null : "?", 1.0f);
                     }
                 } else {
-                    itemModel.renderItemOverlayIntoGUI(Tessellator.instance, this.mc.font, this.mc.textureManager, itemStack, x, y, discovered ? null : "?", 1.0f);
+                    itemModel.renderItemOverlayIntoGUI(GLRenderer.getTessellator(), this.mc.font, this.mc.textureManager, itemStack, x, y, discovered ? null : "?", 1.0f);
                 }
             }
-            GL11.glDisable(GL11.GL_DEPTH_TEST);
+            GLRenderer.disableState(State.DEPTH_TEST);
         }
 
         // Draw selection overlay
         if (isSelected) {
-            GL11.glDisable(GL11.GL_LIGHTING);
-            GL11.glDisable(GL11.GL_DEPTH_TEST);
+            GLRenderer.globalSetLightEnabled(false);
+            GLRenderer.disableState(State.DEPTH_TEST);
             this.drawRect(x, y, x + 16, y + 16, 0x80FFFFFF);
-            GL11.glEnable(GL11.GL_LIGHTING);
-            GL11.glEnable(GL11.GL_DEPTH_TEST);
+            GLRenderer.globalSetLightEnabled(true);
+            GLRenderer.enableState(State.DEPTH_TEST);
         }
 
         // Clean up
-        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
+//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
         Lighting.disable();
-        GL11.glDisable(GL11.GL_LIGHTING);
-        GL11.glDisable(GL11.GL_DEPTH_TEST);
+        GLRenderer.disableState(State.DEPTH_TEST);
     }
 
     public void render(final ItemStack itemStack, final int x, final int y, final boolean isSelected) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ListLayout.java b/game/client/src/main/java/net/minecraft/client/gui/ListLayout.java
index 78e4bb70c..ff763f08d 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ListLayout.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ListLayout.java
@@ -1,131 +1,104 @@
 package net.minecraft.client.gui;
 
-import static org.lwjgl.opengl.GL11.*;
-
 import java.util.ArrayList;
 import java.util.List;
 
-public class ListLayout{
-	
-	public final Screen screen;
-	
-	public final List<GuiElement> elements = new ArrayList<>();
-	
-	public double alignX = 0.0;
-	public double alignY = 0.0;
-	
-	public double alignSelfX = 0.0;
-	public double alignSelfY = 0.0;
-	
-	public int offsetX;
-	public int offsetY;
-	
-	public boolean vertical = true;
-	
-	public int margin = 0;
-	
-	public int elementWidth = 200;
-	public int elementHeight = 20;
-	
-	private int listX;
-	private int listY;
-	
-	private int listWidth;
-	private int listHeight;
-	
-	public ListLayout(Screen screen) {
-		this.screen = screen;
-	}
-	
-	public ListLayout addElement(GuiElement element) {
-		this.elements.add(element);
-		return this;
-	}
-	
-	public void updateElementPositions() {
-		int elementCount = elements.size();
-		
-		if(vertical) {
-			listWidth = elementWidth;
-			listHeight = elementHeight * elementCount + (elementCount - 1) * margin;
-		}else {
-			listWidth = elementWidth * elementCount + (elementCount - 1) * margin;
-			listHeight = elementHeight;
-		}
-		
-		listX = mix(0, screen.width, alignX) + offsetX;
-		listY = mix(0, screen.height, alignY) + offsetY;
-		
-		listX += mix(0, -listWidth, alignSelfX);
-		listY += mix(0, -listHeight, alignSelfY);
-		
-		for(int i=0; i < elements.size(); i++) {
-			GuiElement element = elements.get(i);
-			
-			element.setWidth(elementWidth);
-			element.setHeight(elementHeight);
-			
-			if(vertical) {
-				element.setX(listX);
-				element.setY(listY + i * elementHeight + i * margin);
-			}else {
-				element.setX(listX + i * elementWidth + i * margin);
-				element.setY(listY);
-			}
-		}
-	}
-	
-	public static int mix(int a, int b, double c) {
-		return (int) (a * (1.0 - c) + b * c);
-	}
-	
-	public void drawDebug() {
-		glDisable(GL_TEXTURE_2D);
-		glColor3d(0.1, 0.1, 0.1);
-		drawRectangle(listX-1, listY-1, listWidth+2, listHeight+2);
-		glColor3d(0.2, 0.2, 0.2);
-		drawRectangle(listX, listY, listWidth, listHeight);
-		glColor3d(0.4, 0.4, 0.4);
-		for(GuiElement element : elements) {
-			drawRectangle(element.getX(), element.getY(), element.getWidth(), element.getHeight());
-		}
-	}
-	
-	private static void drawRectangle(int x, int y, int w, int h) {
-		glBegin(GL_QUADS);
-		glVertex2d(x, y);
-		glVertex2d(x, y+h);
-		glVertex2d(x+w, y+h);
-		glVertex2d(x+w, y);
-		glEnd();
-	}
-	
-	public ListLayout setAlign(double x, double y) {
-		this.alignX = x;
-		this.alignY = y;
-		return this;
-	}
-	
-	public ListLayout setVertical(boolean vertical) {
-		this.vertical = vertical;
-		return this;
-	}
-	
-	public ListLayout setElementSize(int width, int height) {
-		this.elementWidth = width;
-		this.elementHeight = height;
-		return this;
-	}
-	
-	public ListLayout setOffset(int x, int y) {
-		this.offsetX = x;
-		this.offsetY = y;
-		return this;
-	}
-	
-	public ListLayout setMargin(int margin) {
-		this.margin = margin;
-		return this;
-	}
-	
+public class ListLayout {
+
+    public final Screen screen;
+
+    public final List<GuiElement> elements = new ArrayList<>();
+
+    public double alignX = 0.0;
+    public double alignY = 0.0;
+
+    public double alignSelfX = 0.0;
+    public double alignSelfY = 0.0;
+
+    public int offsetX;
+    public int offsetY;
+
+    public boolean vertical = true;
+
+    public int margin = 0;
+
+    public int elementWidth = 200;
+    public int elementHeight = 20;
+
+    public ListLayout(Screen screen) {
+        this.screen = screen;
+    }
+
+    public ListLayout addElement(GuiElement element) {
+        this.elements.add(element);
+        return this;
+    }
+
+    public void updateElementPositions() {
+        int elementCount = this.elements.size();
+
+        int listHeight;
+        int listWidth;
+        if (this.vertical) {
+            listWidth = this.elementWidth;
+            listHeight = this.elementHeight * elementCount + (elementCount - 1) * this.margin;
+        } else {
+            listWidth = this.elementWidth * elementCount + (elementCount - 1) * this.margin;
+            listHeight = this.elementHeight;
+        }
+
+        int listX = mix(0, this.screen.width, this.alignX) + this.offsetX;
+        int listY = mix(0, this.screen.height, this.alignY) + this.offsetY;
+
+        listX += mix(0, -listWidth, this.alignSelfX);
+        listY += mix(0, -listHeight, this.alignSelfY);
+
+        for (int i = 0; i < this.elements.size(); i++) {
+            GuiElement element = this.elements.get(i);
+
+            element.setWidth(this.elementWidth);
+            element.setHeight(this.elementHeight);
+
+            if (this.vertical) {
+                element.setX(listX);
+                element.setY(listY + i * this.elementHeight + i * this.margin);
+            } else {
+                element.setX(listX + i * this.elementWidth + i * this.margin);
+                element.setY(listY);
+            }
+        }
+    }
+
+    public static int mix(int a, int b, double c) {
+        return (int) (a * (1.0 - c) + b * c);
+    }
+
+    public ListLayout setAlign(double x, double y) {
+        this.alignX = x;
+        this.alignY = y;
+        return this;
+    }
+
+    public ListLayout setVertical(boolean vertical) {
+        this.vertical = vertical;
+        return this;
+    }
+
+    public ListLayout setElementSize(int width, int height) {
+        this.elementWidth = width;
+        this.elementHeight = height;
+        return this;
+    }
+
+    public ListLayout setOffset(int x, int y) {
+        this.offsetX = x;
+        this.offsetY = y;
+        return this;
+    }
+
+    public ListLayout setMargin(int margin) {
+        this.margin = margin;
+        return this;
+    }
+
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/MainMenuBackground.java b/game/client/src/main/java/net/minecraft/client/gui/MainMenuBackground.java
index 12d80c1fc..5b0894194 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/MainMenuBackground.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/MainMenuBackground.java
@@ -1,7 +1,5 @@
 package net.minecraft.client.gui;
 
-import static org.lwjgl.opengl.GL11.*;
-
 import java.awt.image.BufferedImage;
 import java.io.InputStream;
 import java.util.ArrayList;
@@ -17,11 +15,15 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.OpenGLHelper;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texturepack.TexturePack;
 import net.minecraft.client.render.texturepack.TexturePackException;
 import net.minecraft.client.util.helper.TexturePackJsonHelper;
 import net.minecraft.core.util.helper.Buffer;
+import org.lwjgl.opengl.GL41;
 import org.slf4j.Logger;
 
 public class MainMenuBackground {
@@ -46,22 +48,22 @@ public class MainMenuBackground {
 	private long lastTick = 0;
 	
 	public void draw() {
-		if(backgroundList.isEmpty()) {
+		if(this.backgroundList.isEmpty()) {
 			return;
 		}
 		
-		glClear(GL_COLOR_BUFFER_BIT);
-		glEnable(GL_BLEND);
-		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
+		GL41.glClear(GL41.GL_COLOR_BUFFER_BIT);
+		GLRenderer.enableState(State.BLEND);
+		GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
 		
-		if(backgroundList.size() == 1) {
-			if(currentBackground == null) {
-				currentBackground = loadRandomBackground();
+		if(this.backgroundList.size() == 1) {
+			if(this.currentBackground == null) {
+                this.currentBackground = loadRandomBackground();
 			}
 			
 			OpenGLHelper.checkError("pre draw background");
 			
-			drawImage(currentBackground, 1.0f);
+			drawImage(this.currentBackground, 1.0f);
 			
 			OpenGLHelper.checkError("draw background");
 			
@@ -70,51 +72,57 @@ public class MainMenuBackground {
 		
 		OpenGLHelper.checkError("pre draw background");
 
-		if(currentBackground == null) {
-			currentBackground = loadRandomBackground();
+		if(this.currentBackground == null) {
+            this.currentBackground = loadRandomBackground();
 		}
-		if(nextBackground == null) {
-			nextBackground = loadRandomBackground();
+		if(this.nextBackground == null) {
+            this.nextBackground = loadRandomBackground();
 		}
 		
 		long now = System.currentTimeMillis();
-		float delta = Math.min(((now - lastTick) / 1000.0f), 0.33f);
-		lastTick = now;
-		
-		currentDisplayTime += delta;
+		float delta = Math.min(((now - this.lastTick) / 1000.0f), 0.33f);
+        this.lastTick = now;
+
+        this.currentDisplayTime += delta;
 		
-		if(currentDisplayTime >= displayTime + fadeTime) {
-			currentDisplayTime = 0.0f;
+		if(this.currentDisplayTime >= this.displayTime + this.fadeTime) {
+            this.currentDisplayTime = 0.0f;
 			
-			delete(currentBackground);
-			currentBackground = nextBackground;
-			nextBackground = null;
+			delete(this.currentBackground);
+            this.currentBackground = this.nextBackground;
+            this.nextBackground = null;
 		}
 		
-		drawImage(currentBackground, 1.0f);
+		drawImage(this.currentBackground, 1.0f);
 		
-		float nextBackgroundAlpha = (currentDisplayTime - displayTime) / fadeTime;
+		float nextBackgroundAlpha = (this.currentDisplayTime - this.displayTime) / this.fadeTime;
 		if(nextBackgroundAlpha > 0.0f) {
-			drawImage(nextBackground, nextBackgroundAlpha);	
+			drawImage(this.nextBackground, nextBackgroundAlpha);
 		}
 		
 		OpenGLHelper.checkError("draw background");
 	}
 	
 	private Background loadRandomBackground() {
-		BackgroundListEntry randomBackground = backgroundList.get(random.nextInt(backgroundList.size()));
+		BackgroundListEntry randomBackground = this.backgroundList.get(this.random.nextInt(this.backgroundList.size()));
 
 		BufferedImage image = randomBackground.loadBackgroundImage();
 		
 		Buffer.put(image);
 		
 		int texture = GLAllocation.generateTexture();
-		glBindTexture(GL_TEXTURE_2D, texture);
-		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, image.getWidth(), image.getHeight(), 0, GL_RGBA, GL_UNSIGNED_BYTE, Buffer.buffer);
-		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
-		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
-		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
-		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
+		OpenGLHelper.checkError("setup background5");
+		GL41.glBindTexture(GL41.GL_TEXTURE_2D, texture);
+		OpenGLHelper.checkError("setup background4");
+		GL41.glTexImage2D(GL41.GL_TEXTURE_2D, 0, GL41.GL_RGBA, image.getWidth(), image.getHeight(), 0, GL41.GL_RGBA, GL41.GL_UNSIGNED_BYTE, Buffer.buffer);
+		OpenGLHelper.checkError("setup background3");
+		GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_MIN_FILTER, GL41.GL_LINEAR);
+		OpenGLHelper.checkError("setup background3");
+		GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_MAG_FILTER, GL41.GL_LINEAR);
+		OpenGLHelper.checkError("setup background2");
+		GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_WRAP_S, GL41.GL_CLAMP_TO_EDGE);
+		OpenGLHelper.checkError("setup background1");
+		GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_WRAP_T, GL41.GL_CLAMP_TO_EDGE);
 
 		OpenGLHelper.checkError("setup background");
 		
@@ -123,14 +131,13 @@ public class MainMenuBackground {
 	}
 	
 	private void drawImage(Background background, float alpha) {
-		glEnable(GL_TEXTURE_2D);
-		glBindTexture(GL_TEXTURE_2D, background.texture);
-		glColor4d(0.6, 0.6, 0.6, alpha);
+		GL41.glBindTexture(GL41.GL_TEXTURE_2D, background.texture);
+		GLRenderer.setColor4f(0.6f, 0.6f, 0.6f, alpha);
 
 		int border = 1;
 
-		int displayWidth = mc.resolution.getScaledWidthScreenCoords();
-		int displayHeight = mc.resolution.getScaledHeightScreenCoords();
+		int displayWidth = this.mc.resolution.getScaledWidthScreenCoords();
+		int displayHeight = this.mc.resolution.getScaledHeightScreenCoords();
 		
 		int imageWidth = background.width - 2 * border;
 		int imageHeight = background.height - 2 * border;
@@ -160,9 +167,9 @@ public class MainMenuBackground {
 		float uborder = border / (float) background.width;
 		float vborder = border / (float) background.height;
 		
-		Tessellator tessellator = Tessellator.instance;
+		TessellatorGeneral tessellator = GLRenderer.getTessellator();
 		tessellator.startDrawingQuads();
-		tessellator.setColorRGBA_F(0.75f, 0.75f, 0.75f, alpha);
+		tessellator.setColor4f(0.75f, 0.75f, 0.75f, alpha);
 		tessellator.drawRectangleWithUV(x, y, w, h, uborder, vborder, 1.0 - uborder * 2.0f, 1.0 - vborder * 2.0f);
 		tessellator.draw();
 	}
@@ -171,13 +178,13 @@ public class MainMenuBackground {
 	 * Dont keep textures in memory when loading a world
 	 */
 	public void deleteTextures() {
-		if(currentBackground != null) {
-			delete(currentBackground);
-			currentBackground = null;
+		if(this.currentBackground != null) {
+			delete(this.currentBackground);
+            this.currentBackground = null;
 		}
-		if(nextBackground != null) {
-			delete(nextBackground);
-			nextBackground = null;
+		if(this.nextBackground != null) {
+			delete(this.nextBackground);
+            this.nextBackground = null;
 		}
 	}
 	
@@ -186,16 +193,16 @@ public class MainMenuBackground {
 	}
 	
 	public boolean isEnabled() {
-		return !backgroundList.isEmpty();
+		return !this.backgroundList.isEmpty();
 	}
 	
 	public void refresh(List<Throwable> errors) {
 		deleteTextures();
+
+        this.backgroundList.clear();
 		
-		backgroundList.clear();
-		
-		TexturePack defaultTexturePack = mc.texturePackList.getDefaultTexturePack();
-		TexturePack currentTexturePack = mc.texturePackList.getHighestPriorityPack();
+		TexturePack defaultTexturePack = this.mc.texturePackList.getDefaultTexturePack();
+		TexturePack currentTexturePack = this.mc.texturePackList.getHighestPriorityPack();
 		
 		loadBackgrounds(defaultTexturePack, errors);
 		
@@ -209,7 +216,7 @@ public class MainMenuBackground {
 			JsonObject rootObject = TexturePackJsonHelper.readJsonObject(texturePack, "/bg/backgrounds.json");
 
 			if(rootObject.has("replace") && rootObject.getBoolean("replace")) {
-				backgroundList.clear();
+                this.backgroundList.clear();
 			}
 			
 			JsonArray backgrounds = TexturePackJsonHelper.getArray(rootObject, "backgrounds");
@@ -221,28 +228,28 @@ public class MainMenuBackground {
                         LOGGER.warn("Skipping background '{}'", name);
 						continue;
 					}
-					
-					backgroundList.add(new BackgroundListEntry(texturePack, name));
+
+                    this.backgroundList.add(new BackgroundListEntry(texturePack, name));
 				}
 			}catch (Exception e) {
 				throw new TexturePackException("Error in background.json", e);
 			}
 		}catch (Exception e) {
 			errors.add(e);
-			backgroundList.clear();
+            this.backgroundList.clear();
 		}
 	}
 	
 	public void print() {
 		LOGGER.info("Backgrounds: ");
-		for(BackgroundListEntry bg : backgroundList) {
+		for(BackgroundListEntry bg : this.backgroundList) {
             LOGGER.info("    {}", bg);
 		}
 	}
 	
 	public void nextImage() {
-		if(currentDisplayTime < displayTime) {
-			currentDisplayTime = displayTime;
+		if(this.currentDisplayTime < this.displayTime) {
+            this.currentDisplayTime = this.displayTime;
 		}
 	}
 	
@@ -270,7 +277,7 @@ public class MainMenuBackground {
 		}
 		
 		public BufferedImage loadBackgroundImage() {
-            try (InputStream stream = mc.texturePackList.getResourceAsStream("/bg/" + name + ".png")) {
+            try (InputStream stream = MainMenuBackground.this.mc.texturePackList.getResourceAsStream("/bg/" + this.name + ".png")) {
                 return ImageIO.read(stream);
             } catch (Exception e) {
                 throw new RuntimeException(e);
@@ -278,7 +285,7 @@ public class MainMenuBackground {
 		}
 		
 		public String toString() {
-			return texturePack.manifest.getName() + "/" + name;
+			return this.texturePack.manifest.getName() + "/" + this.name;
 		}
 	}
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/Screen.java b/game/client/src/main/java/net/minecraft/client/gui/Screen.java
index 02e3e754b..32d85eb37 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/Screen.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/Screen.java
@@ -1,14 +1,14 @@
 package net.minecraft.client.gui;
 
-import static org.lwjgl.opengl.GL11.*;
-
 import java.util.ArrayList;
 import java.util.List;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.client.render.font.FontRenderer;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.window.CursorShape;
 import net.minecraft.client.util.debug.DebugRender;
 import net.minecraft.client.input.InputType;
@@ -18,7 +18,6 @@ import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
-import org.lwjgl.opengl.GL11;
 
 public abstract class Screen extends Gui {
     public final @NotNull Minecraft mc = Minecraft.getMinecraft();
@@ -171,14 +170,14 @@ public abstract class Screen extends Gui {
     }
 
     public void renderTexturedBackground() {
-        GL11.glDisable(GL11.GL_LIGHTING);
-        GL11.glDisable(GL11.GL_FOG);
-        final Tessellator tessellator = Tessellator.instance;
+        GLRenderer.globalSetLightEnabled(false);
+//        GL11.glDisable(GL11.GL_FOG);
+        final TessellatorGeneral tessellator = GLRenderer.getTessellator();
         this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        GLRenderer.setColor4f(1f, 1f, 1f, 1f);
         final float scale = 32F;
         tessellator.startDrawingQuads();
-        tessellator.setColorOpaque_I(0x404040);
+        tessellator.setColorOpaque1i(0x404040);
         tessellator.addVertexWithUV(0.0D, this.height, 0.0D, 0.0D, (float) this.height / scale);
         tessellator.addVertexWithUV(this.width, this.height, 0.0D, (float) this.width / scale, (float) this.height / scale);
         tessellator.addVertexWithUV(this.width, 0.0D, 0.0D, (float) this.width / scale, 0);
@@ -188,11 +187,11 @@ public abstract class Screen extends Gui {
 
     public void drawControllerCursor() {
         if (this.mc.controllerInput == null || this.mc.controllerInput.hideCursor) return;
-        glDisable(GL_DEPTH_TEST);
-        glEnable(GL_BLEND);
-        glColor3d(1.0, 1.0, 1.0);
+        GLRenderer.disableState(State.DEPTH_TEST);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setColor3f(1f, 1f, 1f);
         this.drawGuiTexture(this.mc.textureManager, (int) (this.mc.controllerInput.cursorX - 8), (int) (this.mc.controllerInput.cursorY - 8), 16, 16, "/assets/minecraft/textures/gui/controller/cursor.png");
-        glDisable(GL_BLEND);
+        GLRenderer.disableState(State.BLEND);
     }
 
     public void controllerInput(final @NotNull ControllerInput controller) {
